# linux_tools
==============

Linux下有很多命令行工具供我们使用，每个工具总是提供了大量参数供我们选择； 实际工作中，我们用到的工具，最常用的总是那么几个参数组合； 为此，我写了这本书相对实用的书；

这本书专注于Linux工具的最常用用法，以便读者能以最快时间掌握，并在工作中应用；

## 说明

全书分为三个部分：

1. 第一部分为基础篇，介绍我们工作中常用的工具的高频用法；
2. 第二部分为进阶篇，介绍的工具更多的适合程序员使用，分为程序构建、程序调试及程序优化；
3. 第三部分是工具参考篇，主要介绍实用工具的用法和实例；相比第一二部分，这里针对每个工具的介绍更全面；

同时，这个教程也可当作Linux命令手册使用，使用左边栏的目录和搜索栏可以很方便的查阅；

## 写作方式

我将会遵循以下写作方式：  

1. 首先介绍工具的使用范围；
2. 工具的快速上手教程；包含最常用的范例和最常用的选项；
3. 使用场景（例子）说明；
4. 更完整的命令参数说明；
5. 进阶

## 建议
1. 最好安装一个Linux系统（对于新手Ubuntu容易入门），将教程中的命令敲到bash中看看效果
2. 如果有兴趣，可以在了解之后立即查看相关更完备的内容 (比如查阅官方文档)

## 写作工具
本书使用的reStructuredText标记语言，相对Markdown来说，在写书方面更有优势:    

1. 使用Sphinx能够自动生成目录和索引文件，方便查询和检索；
2. 有大量漂亮的HTML书籍主题模版，可为书籍轻松换肤（类似Wordpress的网站模版）；
3. 对于参考手册类书籍的编写在语法上更为便利（python官方帮助文档的使用者）；

## 在线阅读
在线阅读地址：[http://linuxtools-rst.readthedocs.org/zh_CN/latest/](http://linuxtools-rst.readthedocs.org/zh_CN/latest/)

## 版权声明
本书为开源图书，版权归作者所有；欢迎下载及编辑(个人用途)，但未经作者同意必须保留此段声明，且不可用于商业用途，否则保留追究法律责任的权利。

- 作者：大CC
- 博客：http://blog.me115.com
- Github地址：https://github.com/me115/linuxtools_rst

